//autogenerated:yes
//nolint:revive,misspell,govet,lll
package common

// A change to the sequence number indicates that the set of AVAILABLE_MODES has changed.
// A receiver must re-request all available modes whenever the sequence number changes.
// This is only emitted after the first change and should then be broadcast at low rate (nominally 0.3 Hz) and on change.
// See https://mavlink.io/en/services/standard_modes.html
type MessageAvailableModesMonitor struct {
	// Sequence number. The value iterates sequentially whenever AVAILABLE_MODES changes (e.g. support for a new mode is added/removed dynamically).
	Seq uint8
}

// GetID implements the message.Message interface.
func (*MessageAvailableModesMonitor) GetID() uint32 {
	return 437
}
