//autogenerated:yes
//nolint:revive,misspell,govet,lll
package common

// Update the data in the OPEN_DRONE_ID_SYSTEM message with new location information. This can be sent to update the location information for the operator when no other information in the SYSTEM message has changed. This message allows for efficient operation on radio links which have limited uplink bandwidth while meeting requirements for update frequency of the operator location.
type MessageOpenDroneIdSystemUpdate struct {
	// System ID (0 for broadcast).
	TargetSystem uint8
	// Component ID (0 for broadcast).
	TargetComponent uint8
	// Latitude of the operator. If unknown: 0 (both Lat/Lon).
	OperatorLatitude int32
	// Longitude of the operator. If unknown: 0 (both Lat/Lon).
	OperatorLongitude int32
	// Geodetic altitude of the operator relative to WGS84. If unknown: -1000 m.
	OperatorAltitudeGeo float32
	// 32 bit Unix Timestamp in seconds since 00:00:00 01/01/2019.
	Timestamp uint32
}

// GetID implements the message.Message interface.
func (*MessageOpenDroneIdSystemUpdate) GetID() uint32 {
	return 12919
}
